class CM2mdlTreeWalker extends TreeParser;
options
{
   importVocab = CM2mdlParser;
   buildAST = true;
}

model returns [ _model mod ]
{
   String M;
   float V, P;
   
   Vector hlist; // Vector of half spaces
   Vector clist; // Vector of clocks
   Vector mac_list; // Vector of machines
   
   String aregion, iset;
   
   mod = new _model();
}
	: #(LEFTBRACE  M=modelname  V=variables P=parameters
	        hlist=halfspace_list
	        mac_list=machine_list
	        aregion=analysis_region
	        iset=initial_set
	        RIGHTBRACE)           
	        { 
	           mod = new _model(M, V, P, hlist,
	                                        mac_list, aregion, iset); 
	           //System.out.println("IN model");                              
	        }
	;
	
	
modelname returns [ String temp_s ]
{
    temp_s = new String();
}
	:	temp_a:STRING             
	                {
	                   temp_s = new String(temp_a.toString()); 
	                   //System.out.println("Reducing modelname");
	                }
	;

variables returns [ float a ]
{
   float n;
   a = 0;
}
        :   #(VARIABLES n=nnumber)   
                        { 
                           a = n; 
	                   //System.out.println("Reducing variables");
                        }
        ;
        
parameters returns [ float a]
{
   float n;
   a = 0;
}
        :   #(COLON PARAMETERS n=nnumber) 
                        { 
                           a = n ; 
	                   //System.out.println("Reducing parameters");
                        }
        |               { 
	                   //System.out.println("Reducing parameters"); 
	                }   
        ;
       
halfspace_list returns [ Vector hspace_vector ]
{
    _half_space hspace;
    // space_vector is a Vector of "_half_space" objects
     
    hspace_vector = new Vector(3,2);
    Vector hlist;
}
        :   #(HALFSPACES hspace=halfspace hlist=halfspace_list_entries)
                   { 
                      hlist.addElement(hspace);
                      hspace_vector = hlist;
	              //System.out.println("Reducing halfspace_list "); 
                   }
        ;


halfspace_list_entries returns [ Vector hspace_vector ]
{
    _half_space hspace;
    // space_vector is a Vector of "_half_space" objects
    
    hspace_vector = new Vector(3,2);
    Vector hlist;
}
        :   #(HALFSPACE_LIST_ENTRIES_IMG hspace=halfspace hlist=halfspace_list_entries)
                   { 
                      hlist.addElement(hspace);
                      hspace_vector = hlist;
	             // System.out.println("Reducing halfspace_list_entries "); 
                   }
        |          { 
                      hspace_vector = new Vector(3,2);
	            //  System.out.println("Reducing halfspace_list_entries blank "); 
                   }
        ;
        
halfspace returns [ _half_space hspace ]
{
   float f;
   char r;
   Vector v;
   hspace = new _half_space();
}
        :   #(COLON s:STRING v=vector 
                   r=relation f=fnumber) 
                   {
                      hspace = new _half_space(s.toString(), r, f, v);
	             // System.out.println("Reducing halfspace"); 
                   }
        ;

vector returns [ Vector vec ]
{
   float f;
   Vector f_list;
   vec = new Vector(3,2);
}
        :   #(VECTOR_IMG f=fnumber f_list=fnumber_list_entries)
                                     { f_list.addElement(new Float(f));
                                       vec = f_list ;
	                            //   System.out.println("Reducing vector"); 
                                     }
        |                            { 
                                    //    System.out.println("Reducing vector blank"); 
                                     }
        ;

fnumber_list_entries returns [ Vector vec ]
{
   float f;
   Vector f_list;
   vec = new Vector(3,2); 
}
        :  #(COMMA  f=fnumber f_list=fnumber_list_entries)
                                     { f_list.addElement(new Float(f));
                                       vec = f_list ;
	                            //   System.out.println("Reducing fnumber_list_entries"); 
                                     }
        |                            { 
                                    //    System.out.println("Reducing fnumber_list_entries blank"); 
                                     }
        ;
        
machine_list returns [ Vector mac_list ]
{
   mac_list = new Vector(3,2);
   
   Vector mac_liste;
}
        :   #(MACHINE mac_liste=machine_list_entries)
                          {
                             mac_list = mac_liste;
                          }
        ;

machine_list_entries returns [ Vector mac_liste ]
{
   mac_liste = new Vector(3,2);
   
   Vector temp_mac_liste;
   _machine mac;
}
        : #(MACHINE_LIST_ENTRIES_IMG mac=machine temp_mac_liste=machine_list_entries)
                          {
                             temp_mac_liste.addElement(mac);
                             mac_liste = temp_mac_liste;
                          }
        |                 { ; }
        ;
        
machine returns [ _machine mac ]
{
   String ini_loc;
   Vector vlist;
   Vector llist;
   Vector elist;
   
   mac = new _machine();
}
        :   #(s:STRING vlist=variable_list elist=event_list llist=location_list 
                ini_loc=initial_location)
                         {
                            mac = new _machine(s.toString(), vlist, llist, ini_loc, elist);
                         }
        ;

event_list returns [ Vector elist]
{
   elist = new Vector(3,2);
   
   Vector ielist, oelist;
}
        : #(EVENTS ielist=input_event_list  SEMI oelist=output_event_list)
                         {
                            elist.addElement(ielist);
                            elist.addElement(oelist);
                            
                            //System.out.println("GOT event_list !!!");
                         }
        |
        ;

input_event_list returns [ Vector iev_list ]
{
   Vector ev_list;
   iev_list = new Vector(3,2);
}
        : #(s:STRING ev_list=event_list_entries)
                         {
                            ev_list.addElement(s.toString());
                            iev_list = ev_list;
                            
                           // System.out.println("GOT input event list !!!!");
                         }
        |                {;}
        ;

output_event_list  returns [ Vector oev_list ]
{
   Vector ev_list;
   oev_list = new Vector(3,2);
}
        : #(s:STRING ev_list=event_list_entries)
                         {
                            ev_list.addElement(s.toString());
                            oev_list = ev_list;
                            
                           // System.out.println("GOT output event list !!!!");
                         }
        |                {;}
        ;
        
event_list_entries returns [ Vector ev_list ]
{
   Vector elist;
   ev_list = new Vector(3,2);
}
        : #(s:STRING elist=event_list_entries)
                         {
                            elist.addElement(s.toString());
                            ev_list = elist;
                         }
        |
        ;
        
variable_list returns [ Vector vlist ]
{
   float f;
   Vector f_list;
   
   vlist = new Vector(3,2);
}
        :   #(VARIABLE f=fnumber f_list=fnumber_list_entries)
                         {
                            f_list.addElement(new Float(f));
                            vlist = f_list;
                         }
        |                {;}
        ;

location_list returns [ Vector llist ]
{
   llist = new Vector(3,2);
   
   Vector lliste;
}
        :   #(LOCATIONS lliste=location_list_entries)
                         {
                            llist = lliste;
                         }
        ;

initial_location returns [ String ini_loc ]
{
   ini_loc = " ";
}
        :   #(INITIAL_LOCATION s:STRING) 
                         {
                            ini_loc = s.toString();
                         }
        ;

location_list_entries returns [ Vector llist ]
{
   Vector temp_llist;
   _location loc;
   
   llist = new Vector(3,2);
}
        : #( LOCATION_LIST_ENTRIES_IMG loc=location temp_llist=location_list_entries)
                          {
                             temp_llist.addElement(loc);
                             llist = temp_llist;
                          }
        | 
        ;

location returns [ _location loc ]
{
   String inv,par_con;
   
   Vector tlist;
   _behaviour bhvr;
   
   loc = new _location();
}
        :   #(s:STRING bhvr=behaviour inv=invariant
           par_con=parameter_constraint tlist=transition_list)
                          {
                             loc = new _location(s.toString(), bhvr, inv, par_con, tlist);
                          }
        ;

behaviour returns [ _behaviour bhvr ]
{
   _linearmap lmap;
   Vector rlist;
   Vector nlmap;
   
   bhvr = new _behaviour();
}
        :   #(i:INTEGRATOR rlist=rate_list)
                            {
                               bhvr = new _behaviour(i.toString(),rlist);
                            }
        |   #(l:LINEAR lmap=linearmap)
                            {
                               bhvr = new _behaviour(l.toString(),lmap);
                            }
        | #(n:NONLINEAR nlmap=nonlinearmap)
                            {
                               bhvr = new _behaviour(n.toString(),nlmap);
                            }
        |                   {;}
        ;

rate_list returns [ Vector rlist ]
{
   float f;
   Vector f_list;
   
   rlist = new Vector(3,2);
}
        :   #(SEMI f=fnumber f_list=fnumber_list_entries)
                              {
                                 f_list.addElement(new Float(f));
                                 rlist = f_list;
                              }
        ;

linearmap returns [ _linearmap lmap ]
{
   float f;
   Vector v;
   
   Vector vec; // A vector of 'Float Vectors'
   Vector lin_fvec;
   
   lmap = new _linearmap();
}
        :   #(COMMA v=vector vec=linearmap_vectors f=fnumber lin_fvec=linearmap_fnumbers)
                              {
                                 vec.addElement(v);
                                 lin_fvec.addElement(new Float(f));
                                 lmap = new _linearmap(vec,lin_fvec);
                              }
            
        ;

linearmap_vectors returns [ Vector vec ]
{
   Vector v; // a vector of Floats
   Vector lvec;
   
   lvec = new Vector(3,2); // These are vectors of vectors
   vec = new Vector(3,2);
}
        : #(SEMI v=vector lvec=linearmap_vectors)
                              {
                                 lvec.addElement(v);
                                 vec = lvec;
                              }
        |                     { ; }
        ;

linearmap_fnumbers  returns [ Vector lin_fvec ]
{
   float f;
   
   Vector lfn;
   lin_fvec = new Vector(3,2);
}
        :  #(SEMI f=fnumber lfn=linearmap_fnumbers)
                              {
                                 lfn.addElement(new Float(f));
                                 lin_fvec = lfn;
                              }
        |                     { ; }
        ;
        
nonlinearmap returns [ Vector nlmap ]
{
   nlmap = new Vector(3,2);
   
   Vector temp_nlmap;
   String ode;
}
        :   #(SEMI ode=ode_rhs temp_nlmap=nonlinearmap)
                          {
                             temp_nlmap.addElement(ode);
                             nlmap = temp_nlmap;
                          }
        |                 { ; }
        ;

ode_rhs returns [ String ode ]
{
   String exp1, exp2;
   
   ode = " ";
}
        :  #(c:OP exp1=expr) { ode = c + exp1 ; }
        |  #(ODE_RHS_IMG exp2=expr) { ode = exp2; }
        ;

expr returns [ String exp ]
{
   String uexp, exp_list;
   
   exp = " ";
}
        :  #(EXPR_IMG uexp=u_expr exp_list=expr_list)
                            {
                               exp = uexp + exp_list;
                            }
        ;

expr_list returns [ String explist ]
{
   String uexp, temp_explist;
   
   explist = " ";
}
        :  #(c:OP uexp=u_expr temp_explist=expr_list)
                             {
                                explist = c + uexp + temp_explist + " ";
                             }
        |                    { ; }
        ;

u_expr returns [ String uexp ]
{
    float f;
    
    String func, str_exp;
    
    uexp = "";
}
        :   #(U_EXPR_IMG func=function)  { uexp = func ; }
        |   #(U_EXPR_IMG2 f=fnumber)     { uexp = f + " ";}
        |   #(LEFTPAREN str_exp=expr RIGHTPAREN) 
                      { 
                         uexp = "(" + str_exp + ")" ;
                      }                 
        ;
        
function returns [ String func ]
{
   func = "";
   
   String a_args;
}
	:   #(s:STRING a_args=a_arguments)
	                    {
	                       func = s + "("+a_args+")";
	                    }
	;

a_arguments returns [ String a_args ]
{
   a_args = "";
   
   String a_arg, a_arglist;
}
        :  #(A_ARGUMENTS_IMG a_arg=a_argument a_arglist=a_arguments_list)
                             {
                                a_args = a_arg + " " +a_arglist;
                             }
        ;

a_arguments_list returns [ String a_arglist ]
{
   a_arglist = "";
   
   String a_arg, temp_a_arglist;
}
        :   #(COMMA a_arg=a_argument temp_a_arglist=a_arguments_list)
                              {
                                 a_arglist = a_arg +" "+ temp_a_arglist;
                              }
        |                     { ; }
        ;

a_argument returns [ String a_arg ]
{
   float f;
   
   a_arg = "";
   
   String func;
}
        :  #(A_ARGUMENT1_IMG f=fnumber)
                               {
                                  a_arg = f + "";
                               }
        |  #(A_ARGUMENT2_IMG func=function)
                               {
                                  a_arg = func;
                               }
        ;
        
invariant returns [ String inv ]
{
   String bfunc;
   
   inv = "";
}
        :  #(INVARIANT bfunc=boolean_function)
                                {
                                   inv = bfunc;
                                }
        |                       { ; }
        ;

parameter_constraint returns [ String par_con ]
{
   String bfunc;
   
   par_con = " ";
}
        :  #(PAR_CONSTRAINT bfunc=boolean_function)
                                {
                                   par_con = bfunc;
                                }
        |                       { ; }
        ;

transition_list returns [ Vector tlist ]
{
   _transition trans; 
   tlist = new Vector(3,2);
   
   Vector temp_tlist;
}
        :   #(TRANSITIONS trans=transition temp_tlist=transition_list_entries)
                                {
                                   temp_tlist.addElement(trans);
                                   tlist = temp_tlist;
                                }
        |                       { ; }
        ;  

transition_list_entries returns [ Vector tliste ]
{
   _transition trans;
   
   Vector temp_tlist; // Vector of transitions
   
   tliste = new Vector(3,2);
}
        : #(TRANSITION_LIST_ENTRIES_IMG trans=transition temp_tlist=transition_list_entries)
                               {
                                  temp_tlist.addElement(trans);
                                  tliste = temp_tlist;
                               }
        |
        ;
        
transition returns [ _transition trans ]
{
   String t, c, grd,oe;
   _linearmap rmap;
   String ie;
   
   trans = new _transition();
}
        :   #(s:STRING t=target grd=guard rmap=reset
                c=clock_flag ie=ievent oe=oevent)
                                {
                                   if(!ie.equals("")){
                                      trans = new  _transition(
                                          s.toString(), t, grd, rmap, c, oe, 1);
                                   }
                                   else{
                                      trans = new  _transition(
                                          s.toString(), t, grd, rmap, c, oe, 0);
                                   }
                                          
                                   // ie is being ignored .. it is assumed to be in
                                   // the guard.
                                  // System.out.println("Making transition");
                                  // System.out.println("resetmap.vecs.size = " + rmap.vecs.size() );
                                }
        ;

ievent returns [ String ie]
{
   ie = "";
}
        : #(IEVENT s:STRING )   
                                {
                                   ie = s.toString();
                                }
        |
        ;
        
oevent returns [ String oe ]
{
   oe = "";
}
        : #(OEVENT s:STRING)   { oe = s.toString(); }
        |
        ;
        
target returns [ String s ]
{
   s = new String();
}
        :  #(TARGET a:STRING)    { s = new String(a.toString()); }
        ;

guard returns [ String grd ]
{
   String bfunc;
   
   grd = " ";
}
        :  #(GUARD bfunc=boolean_function)
                         {
                            grd = bfunc;
                         }
        ;

reset returns [ _linearmap rmap ]
{
   _linearmap lmap;
   
   rmap = new _linearmap();
}
        :   #(RESET lmap=linearmap)
                          {
                             rmap = lmap;
                             // System.out.println("Found reset");
                          }
        |                 { ; }
        ;

clock_flag returns [ String s ]
{
   s = new String();
}
        :   #(CLOCK a:STRING)    { s = new String(a.toString()); }
        |
        ;
        
analysis_region returns [ String aregion ]
{
   String bfunc;
   
   aregion = " ";
}
        :   #(ANALYSIS_REGION bfunc=boolean_function)
                           {
                               aregion = bfunc;
                           }
        ;

initial_set returns [ String iset ]
{
   String bfunc;
   
   iset = " ";
}
        :   #(INITIAL_SET bfunc=boolean_function)
                           {
                              iset = bfunc;
                           }
        ;

boolean_function returns [ String bfunc ]
{
   String larg;
   String bflist;
   
   bfunc = " ";
}
        :   #(BOOL_FUNC larg=l_argument bflist=bool_func_list)
                   {
                      bfunc = larg + bflist;
                   }
        ;

bool_func_list returns [ String bflist ]
{
   char o;
   String larg;
   String temp_bflist;
   
   bflist = " ";
}
        :  #(BOOL_FUNC_LIST_IMG o=operator larg=l_argument temp_bflist=bool_func_list)
                   {
                      bflist = o + larg + temp_bflist;
                   }
        |          { ; }
        ;
        
l_argument returns [ String ret_larg ]
{
   ret_larg = " ";
   String temp_larg, larg_1, temp2_larg, larg_2;
}
        :   #(LEFTPAREN temp_larg=l_argument RIGHTPAREN 
                  larg_1=l_argument_one)
                  {
                     ret_larg = "(" + temp_larg + ")" + larg_1 ;
                  }
        |   #(NOT temp2_larg=l_argument)
                  {
                     ret_larg = "~" + temp2_larg ;
                  }
        |   #(s:STRING larg_2=l_argument_two)
                  {
                     ret_larg = s + larg_2 ;
                  }
        ;

l_argument_one returns [ String larg_1 ]
{
   char o;
   larg_1 = " ";
   String larg;
   String larg_one;
   
}
        :  #(L_ARGUMENT_1_IMG o=operator larg=l_argument larg_one=l_argument_one)
                              { larg_1 = o + larg + larg_one; }
        |                     { ; }
        ;
        
l_argument_two returns [ String larg_2 ]
{
   char o;
   larg_2 = " ";
   String larg;
}
        :  #(L_ARGUMENT_2_IMG o=operator larg=l_argument)
                               { larg_2 = o + larg ; }
        |                      { ; }
        ; 
        
operator returns [ char c ]
{
   c = ' ';
}
        :  AND    { c = '&'; }
        |  OR     { c = '|'; }
        ; 
        
relation returns [ char c ]
{
   c = ' ';
}
        :  SMALLER   { c = '<';}
        |  GREATER   { c = '>';}
        |  EQUAL     { c = '=';}
        ;
        
        
nnumber returns [ float a ]
{
    a = 0; 
}
        :   #(o:OP n:FLOAT)   { 
                                 a = Float.parseFloat(n.toString()); 
                                 if(o.toString().equals("-")) a = -a;
                              } 
        |   m:FLOAT         { a = Float.parseFloat(m.toString()); }
	;


fnumber returns [float a ]
{
    a = 0; 
}
        :   #(o:OP n:FLOAT)   { a = Float.parseFloat(n.toString()); 
                                 if(o.toString().equals("-")) a = -a;
                              // System.out.println(n.toString());
                            } 
        |   m:FLOAT         { a = Float.parseFloat(m.toString());
                              // System.out.println(m.toString()); 
                            }
        ;
       
