import java.io.*;
import java.lang.*;
import java.util.*;
import antlr.CommonAST;
import antlr.collections.AST;
import antlr.DumpASTVisitor;
import antlr.RecognitionException;
import antlr.TokenStreamException;

class _half_space{
	String name;
	public char relation;
	public float fnumber;
	public Vector vec;

	_half_space(String name, char relation, float fnumber, Vector vec)
	{
		this.name = name;
		this.relation = relation;
		this.fnumber = fnumber;
		this.vec = vec;
	}

	_half_space()
    {
			this.relation = ' ';
			this.fnumber = 0;
			name = " ";
			this.vec = new Vector(3);
	}
}

class _linearmap{
	Vector vecs;
	Vector fnumbers;

	_linearmap(Vector vecs, Vector fnumbers)
	{
		this.vecs = vecs;
		this.fnumbers = fnumbers;
	}

	_linearmap()
    {
		vecs = new Vector(3,2);
		fnumbers = new Vector(3,2);
	}
}

class _transition{
	String name;
	String target;
	String guard;
	_linearmap reset;
	String clk_flag;
	String oevent; // output event
	int iev_flag;

	_transition(String name, String target, String guard, _linearmap reset,
	            String clk_flag, String oevent, int iev_flag)
	{
		this.name = name;
		this.target = target;
		this.guard = guard;
		this.reset = reset;
		this.clk_flag = clk_flag;
		this.oevent = oevent;
		this.iev_flag=iev_flag;
	}

	_transition()
    {
		name = " ";
		target = " ";
		guard = " ";
		reset = new _linearmap();
		clk_flag = " ";

		oevent="";
		iev_flag=0;
	}
}

class _behaviour{
	String type;
	Vector vec;
	_linearmap lmap;

	_behaviour(String type, Vector vec)
	{
		this.type = type;
		this.vec = vec;
	}

    _behaviour(String type, _linearmap lmap)
		{
			this.type = type;
			this.lmap = lmap;
	}

	_behaviour()
    {
		type = " ";
		vec = new Vector(3,2);
	}
}

class _location{
	String name;
	_behaviour bhvr;
	String inv, par_con;
	Vector tlist;
	_linearmap reset;
	int entering_resets;
	int entering_trans;
	int reset_flag;

	_location(String name, _behaviour bhvr, String inv, String par_con, Vector tlist)
	{
		this.name = name;
		this.bhvr = bhvr;
		this.inv = inv;
		this.par_con = par_con;
		this.tlist = tlist;

		reset = new _linearmap();
		entering_resets = 0;
		entering_trans=0;
		reset_flag=0;
	}

	_location()
    {
		bhvr = new _behaviour();
		inv = " ";
		par_con = " ";
		name = " ";
		tlist = new Vector(3,2);

		reset = new _linearmap();
		entering_resets = 0;
		entering_trans=0;
		reset_flag=0;
	}

	_location(_location loc)
	{
		this.name = loc.name;
		this.bhvr=loc.bhvr;
		this.inv=loc.inv;
		this.par_con=loc.par_con;
		this.tlist=loc.tlist;

		this.reset=loc.reset;
		this.entering_resets=loc.entering_resets;
		this.entering_trans=loc.entering_trans;
		this.reset_flag=loc.reset_flag;
	}
}


class _machine{
	String name;
	Vector vlist;
	String ini_loc;
	Vector llist;
	Vector elist;

	_machine(String name,Vector vlist, Vector llist, String ini_loc, Vector elist)
	{
		this.name = name;
		this.ini_loc = ini_loc;
		this.llist = llist;
		this.vlist = vlist;
		this.elist=elist;
	}

	_machine()
    {
		ini_loc = " ";
		name = " ";
		vlist = new Vector(3,2);
		llist = new Vector(3,2);
		elist=new Vector(3,2);
	}
}


class _model{
	String mod;
	float var, par;
	Vector hlist;
	Vector mac_list;
	String aregion, iset;

	_model(String mod, float var, float par, Vector hlist,
	         Vector mac_list, String aregion, String iset)
	{
		this.mod = mod;
		this.var = var;
		this.par = par;
		this.hlist = hlist;
		this.mac_list = mac_list;
		this.aregion = aregion;
		this.iset = iset;
	}

	_model()
    {
		iset = " ";
		aregion = " ";
		mod = " ";
		var = 0;
		par = 0;
		hlist = new Vector(3,2);
		mac_list = new Vector(3,2);
	}
}